• 【LeetCode题目详解】第九章 动态规划part08 139.单词拆分 (day46补)


    本文章代码以c++为例!

    一、力扣第139题:单词拆分

    题目:

    给你一个字符串 s 和一个字符串列表 wordDict 作为字典。请你判断是否可以利用字典中出现的单词拼接出 s

    注意:不要求字典中出现的单词全部都使用,并且字典中的单词可以重复使用。

    示例 1:

    输入: s = "leetcode", wordDict = ["leet", "code"]
    输出: true
    解释: 返回 true 因为 "leetcode" 可以由 "leet" 和 "code" 拼接成。
    

    示例 2:

    输入: s = "applepenapple", wordDict = ["apple", "pen"]
    输出: true
    解释: 返回 true 因为 "applepenapple" 可以由 "apple" "pen" "apple" 拼接成。
         注意,你可以重复使用字典中的单词。
    

    示例 3:

    输入: s = "catsandog", wordDict = ["cats", "dog", "sand", "and", "cat"]
    输出: false
    

    提示:

    • 1 <= s.length <= 300
    • 1 <= wordDict.length <= 1000
    • 1 <= wordDict[i].length <= 20
    • swordDict[i] 仅由小写英文字母组成
    • wordDict 中的所有字符串 互不相同

    思路

    看到这道题目的时候,大家应该回想起我们之前讲解回溯法专题的时候,讲过的一道题目回溯算法:分割回文串

    (opens new window),就是枚举字符串的所有分割情况。

    回溯算法:分割回文串

    (opens new window):是枚举分割后的所有子串,判断是否回文。

    本道是枚举分割所有字符串,判断是否在字典里出现过。

    那么这里我也给出回溯法C++代码:

    1. class Solution {
    2. private:
    3. bool backtracking (const string& s, const unordered_set& wordSet, int startIndex) {
    4. if (startIndex >= s.size()) {
    5. return true;
    6. }
    7. for (int i = startIndex; i < s.size(); i++) {
    8. string word = s.substr(startIndex, i - startIndex + 1);
    9. if (wordSet.find(word) != wordSet.end() && backtracking(s, wordSet, i + 1)) {
    10. return true;
    11. }
    12. }
    13. return false;
    14. }
    15. public:
    16. bool wordBreak(string s, vector& wordDict) {
    17. unordered_set wordSet(wordDict.begin(), wordDict.end());
    18. return backtracking(s, wordSet, 0);
    19. }
    20. };
    • 时间复杂度:O(2^n),因为每一个单词都有两个状态,切割和不切割
    • 空间复杂度:O(n),算法递归系统调用栈的空间

    那么以上代码很明显要超时了,超时的数据如下:

    1. "aaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaaab"
    2. ["a","aa","aaa","aaaa","aaaaa","aaaaaa","aaaaaaa","aaaaaaaa","aaaaaaaaa","aaaaaaaaaa"]

    递归的过程中有很多重复计算,可以使用数组保存一下递归过程中计算的结果。

    这个叫做记忆化递归,这种方法我们之前已经提过很多次了。

    使用memory数组保存每次计算的以startIndex起始的计算结果,如果memory[startIndex]里已经被赋值了,直接用memory[startIndex]的结果。

    C++代码如下:

    1. class Solution {
    2. private:
    3. bool backtracking (const string& s,
    4. const unordered_set& wordSet,
    5. vector<bool>& memory,
    6. int startIndex) {
    7. if (startIndex >= s.size()) {
    8. return true;
    9. }
    10. // 如果memory[startIndex]不是初始值了,直接使用memory[startIndex]的结果
    11. if (!memory[startIndex]) return memory[startIndex];
    12. for (int i = startIndex; i < s.size(); i++) {
    13. string word = s.substr(startIndex, i - startIndex + 1);
    14. if (wordSet.find(word) != wordSet.end() && backtracking(s, wordSet, memory, i + 1)) {
    15. return true;
    16. }
    17. }
    18. memory[startIndex] = false; // 记录以startIndex开始的子串是不可以被拆分的
    19. return false;
    20. }
    21. public:
    22. bool wordBreak(string s, vector& wordDict) {
    23. unordered_set wordSet(wordDict.begin(), wordDict.end());
    24. vector<bool> memory(s.size(), 1); // -1 表示初始化状态
    25. return backtracking(s, wordSet, memory, 0);
    26. }
    27. };

    这个时间复杂度其实也是:O(2^n)。只不过对于上面那个超时测试用例优化效果特别明显。

    这个代码就可以AC了,当然回溯算法不是本题的主菜,背包才是!

    # 背包问题

    单词就是物品,字符串s就是背包,单词能否组成字符串s,就是问物品能不能把背包装满。

    拆分时可以重复使用字典中的单词,说明就是一个完全背包!

    动规五部曲分析如下:

    1. 确定dp数组以及下标的含义

    dp[i] : 字符串长度为i的话,dp[i]为true,表示可以拆分为一个或多个在字典中出现的单词

    1. 确定递推公式

    如果确定dp[j] 是true,且 [j, i] 这个区间的子串出现在字典里,那么dp[i]一定是true。(j < i )。

    所以递推公式是 if([j, i] 这个区间的子串出现在字典里 && dp[j]是true) 那么 dp[i] = true。

    1. dp数组如何初始化

    从递推公式中可以看出,dp[i] 的状态依靠 dp[j]是否为true,那么dp[0]就是递推的根基,dp[0]一定要为true,否则递推下去后面都都是false了。

    那么dp[0]有没有意义呢?

    dp[0]表示如果字符串为空的话,说明出现在字典里。

    但题目中说了“给定一个非空字符串 s” 所以测试数据中不会出现i为0的情况,那么dp[0]初始为true完全就是为了推导公式。

    下标非0的dp[i]初始化为false,只要没有被覆盖说明都是不可拆分为一个或多个在字典中出现的单词。

    1. 确定遍历顺序

    题目中说是拆分为一个或多个在字典中出现的单词,所以这是完全背包。

    还要讨论两层for循环的前后顺序。

    如果求组合数就是外层for循环遍历物品,内层for遍历背包

    如果求排列数就是外层for遍历背包,内层for循环遍历物品

    我在这里做一个总结:

    求组合数:动态规划:518.零钱兑换II

    (opens new window) 求排列数:动态规划:377. 组合总和 Ⅳ (opens new window)动态规划:70. 爬楼梯进阶版(完全背包) (opens new window) 求最小数:动态规划:322. 零钱兑换 (opens new window)动态规划:279.完全平方数

    (opens new window)

    而本题其实我们求的是排列数,为什么呢。 拿 s = "applepenapple", wordDict = ["apple", "pen"] 举例。

    "apple", "pen" 是物品,那么我们要求 物品的组合一定是 "apple" + "pen" + "apple" 才能组成 "applepenapple"。

    "apple" + "apple" + "pen" 或者 "pen" + "apple" + "apple" 是不可以的,那么我们就是强调物品之间顺序。

    所以说,本题一定是 先遍历 背包,再遍历物品。

    1. 举例推导dp[i]

    以输入: s = "leetcode", wordDict = ["leet", "code"]为例,dp状态如图:

    139.单词拆分

    dp[s.size()]就是最终结果。

    动规五部曲分析完毕,C++代码如下:

    1. class Solution {
    2. public:
    3. bool wordBreak(string s, vector& wordDict) {
    4. unordered_set wordSet(wordDict.begin(), wordDict.end());
    5. vector<bool> dp(s.size() + 1, false);
    6. dp[0] = true;
    7. for (int i = 1; i <= s.size(); i++) { // 遍历背包
    8. for (int j = 0; j < i; j++) { // 遍历物品
    9. string word = s.substr(j, i - j); //substr(起始位置,截取的个数)
    10. if (wordSet.find(word) != wordSet.end() && dp[j]) {
    11. dp[i] = true;
    12. }
    13. }
    14. }
    15. return dp[s.size()];
    16. }
    17. };
    • 时间复杂度:O(n^3),因为substr返回子串的副本是O(n)的复杂度(这里的n是substring的长度)
    • 空间复杂度:O(n)

    # 拓展

    关于遍历顺序,再给大家讲一下为什么 先遍历物品再遍历背包不行。

    这里可以给出先遍历物品再遍历背包的代码:

    1. class Solution {
    2. public:
    3. bool wordBreak(string s, vector& wordDict) {
    4. unordered_set wordSet(wordDict.begin(), wordDict.end());
    5. vector<bool> dp(s.size() + 1, false);
    6. dp[0] = true;
    7. for (int j = 0; j < wordDict.size(); j++) { // 物品
    8. for (int i = wordDict[j].size(); i <= s.size(); i++) { // 背包
    9. string word = s.substr(i - wordDict[j].size(), wordDict[j].size());
    10. // cout << word << endl;
    11. if ( word == wordDict[j] && dp[i - wordDict[j].size()]) {
    12. dp[i] = true;
    13. }
    14. // for (int k = 0; k <= s.size(); k++) cout << dp[k] << " "; //这里打印 dp数组的情况
    15. // cout << endl;
    16. }
    17. }
    18. return dp[s.size()];
    19. }
    20. };

    使用用例:s = "applepenapple", wordDict = ["apple", "pen"],对应的dp数组状态如下:

    最后dp[s.size()] = 0 即 dp[13] = 0 ,而不是1,因为先用 "apple" 去遍历的时候,dp[8]并没有被赋值为1 (还没用"pen"),所以 dp[13]也不能变成1。

    除非是先用 "apple" 遍历一遍,再用 "pen" 遍历,此时 dp[8]已经是1,最后再用 "apple" 去遍历,dp[13]才能是1。

    如果大家对这里不理解,建议可以把我上面给的代码,拿去力扣上跑一跑,把dp数组打印出来,对着递推公式一步一步去看,思路就清晰了。

    # 总结

    本题和我们之前讲解回溯专题的回溯算法:分割回文串

    (opens new window)非常像,所以我也给出了对应的回溯解法。

    稍加分析,便可知道本题是完全背包,是求能否组成背包,而且这里要求物品是要有顺序的。

  • 相关阅读:
    ubuntu 20通过docker安装onlyoffice,并配置https访问
    Hash表_拉链法_开放寻址法_模拟散列表
    决策树和随机森林
    golang leetcode算法小抄
    加速大模型落地!中兴通讯携手 1024 程序员节设立 AICon 人工智能大模型工程化论坛
    SpringBoot 自动装配原理
    亚马逊云科技多位AI大咖现身,都谈了些什么?
    3.4.3 终结操作
    C# WPF入门学习主线篇(二十九)—— 绑定到对象和集合
    lammps教程:原子平动和振动的设置方法
  • 原文地址:https://blog.csdn.net/weixin_67972246/article/details/132781277